<!DOCTYPE html>
<html lang="en">
	<head>
		<meta charset="UTF-8">
		<!-- Responsive meta tags -->
		<meta name="viewport" content="width=device-width, initial-scale=1.0, shrink-to-fit=no">
		<!-- Bootstrap CSS v4.6 -->
		<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
		<title>Bootstrap Flex</title>
	</head>
	<body>
		<div class="container">
			<div class="row">
				<div class="col-md-6 mx-md-auto bg-warning">
					<h1 class="text-center">Bootstrap Flex</h1>
				</div>
			</div>
		</div>
		<!-- End of Container -->
		<!-- Flexbox is used to manipulate or layout elements on one direction.
			To add flexbox, use d-flex class to the parent element. Each of the direct child of the parent becomes a flex item. 
			flex-row starts from left to right. Flex row reverse starts our items from right to left. The child will be on the same row as the parent. 
			flex-column will arrange the items from top to bottom and the children will occupy the width of the parents.  
			flex-column-reverse - does the same as the flex-column, but it arranges the items from bottom to top
		 -->
		 <h4>Flex Row</h4>
		 <div class="d-flex flex-row bg-dark mb-4">
		 	<div class="bg-primary p-2">Flex 1</div>
		 	<div class="bg-success p-2">Flex 2</div>
		 	<div class="bg-danger p-2">Flex 3</div>
		 </div>		

		 <h4>Flex Row Reverse</h4>
		 <div class="d-flex flex-row-reverse bg-dark mb-4">
		 	<div class="bg-primary p-2">Flex 1</div>
		 	<div class="bg-success p-2">Flex 2</div>
		 	<div class="bg-danger p-2">Flex 3</div>
		 </div>		 

		 <h4>Flex Column</h4>
		 <div class="d-flex flex-column bg-dark mb-4">
		 	<div class="bg-primary p-2">Flex 1</div>
		 	<div class="bg-success p-2">Flex 2</div>
		 	<div class="bg-danger p-2">Flex 3</div>
		 </div>
		 <h4>Flex Column</h4>
		 <div class="d-flex flex-column-reverse bg-dark mb-4">
		 	<div class="bg-primary p-2">Flex 1</div>
		 	<div class="bg-success p-2">Flex 2</div>
		 	<div class="bg-danger p-2">Flex 3</div>
		 </div>
		 <!-- Justify Content -->
		 <h2 class="text-center">Justify Content</h2>
		 <!-- justify-content - allows us to change the alignment of our flex items along its main axis inside the container
		For flex-row, main axis is the main axis.
		For flex-column, the main axis is the y-axis. 
		  -->
		  <h4 class="text-center">Justify Content Start</h4>
		  <!-- Aligns the children from the left of the main axis-->
		  <div class="d-flex flex-row justify-content-start bg-dark mb-4">
		  	<div class="bg-primary p-2">Flex Item 1</div>
		  	<div class="bg-success p-2">Flex Item 2</div>
		  	<div class="bg-danger p-2">Flex Item 3</div>
		  </div>

		  <h4 class="text-center">Justify Content End</h4>
		  <!-- Aligns the children from the right of the main axis-->
		  <div class="d-flex flex-row justify-content-end bg-dark mb-4">
		  	<div class="bg-primary p-2">Flex Item 1</div>
		  	<div class="bg-success p-2">Flex Item 2</div>
		  	<div class="bg-danger p-2">Flex Item 3</div>
		  </div>	

		  <h4 class="text-center">Justify Content Center</h4>
		  <!-- Aligns the children in the center of the main axis -->
		  <div class="d-flex flex-row justify-content-center bg-dark mb-4">
		  	<div class="bg-primary p-2">Flex Item 1</div>
		  	<div class="bg-success p-2">Flex Item 2</div>
		  	<div class="bg-danger p-2">Flex Item 3</div>
		  </div>

		  <h4 class="text-center">Justify Content Center - Flex Reverse</h4>
		  <!-- Aligns the children in the center of the main axis -->
		  <div class="d-flex flex-row-reverse justify-content-center bg-dark mb-4">
		  	<div class="bg-primary p-2">Flex Item 1</div>
		  	<div class="bg-success p-2">Flex Item 2</div>
		  	<div class="bg-danger p-2">Flex Item 3</div>
		  </div>		  

		  <h4 class="text-center">Justify Content Center - Flex Column</h4>
		  <!-- Aligns the children in the center of the main axis -->
		  <div class="d-flex flex-column justify-content-center bg-dark mb-4">
		  	<div class="bg-primary p-2">Flex Item 1</div>
		  	<div class="bg-success p-2">Flex Item 2</div>
		  	<div class="bg-danger p-2">Flex Item 3</div>
		  </div>
		  <h4 class="text-center">Justify Content Center - Align-item-center- Flex Column</h4>
		  <!-- Aligns the children in the center of the main axis (y-axis in this case)-->
		  <div class="d-flex flex-column justify-content-center align-items-center bg-dark mb-4">
		  	<div class="bg-primary p-2">Flex Item 1</div>
		  	<div class="bg-success p-2">Flex Item 2</div>
		  	<div class="bg-danger p-2">Flex Item 3</div>
		  </div>
		  <h4 class="text-center">Justify Content Between</h4>
		  <!--Evenly spaces the space between the children/items, with the left and right items stuck to the edges of the container -->
		  <div class="d-flex flex-row justify-content-between bg-dark mb-4">
		  	<div class="bg-primary p-2">Flex Item 1</div>
		  	<div class="bg-success p-2">Flex Item 2</div>
		  	<div class="bg-danger p-2">Flex Item 3</div>
		  </div>		  
		  <h4 class="text-center">Justify Content Around</h4>
		  <!--Evenly spaces the space between the children/items, but there is a space between the left/right item and the edges. 
			  flex-wrap will allow us to wrap our overflowing elements, such that if the children of the flex container exceeds the width, the flex items will
			  go to the next line. 
		   -->
		  <div class="d-flex flex-row justify-content-around flex-wrap bg-dark mb-4">
		  	<div class="bg-primary p-2">Flex Item 1</div>
		  	<div class="bg-success p-2">Flex Item 2</div>
		  	<div class="bg-danger p-2">Flex Item 3</div>
		  	<div class="bg-info p-2">Flex Item 4</div>
		  	<div class="bg-secondary p-2">Flex Item 5</div>
		  	<div class="bg-warning p-2">Flex Item 6</div>
		  </div>

		  <!-- Align Items -->
		  <h2 class="text-center">Align Items</h2>
		  <!-- Aligns our items vertically for flex-row and horizontally for flex-column. 
		   -->
		   <h4 class="text-center">Align Items Start</h4>
		   <!-- Align the items from the start of the y-axis.
				For flex-row, it is at the top. 
				For flex-column, it is at the left.
		    -->
		    <div class="d-flex flex-row align-items-start bg-dark mb-4" style="height:300px">
		    	<div class="bg-primary p-2">Flex Item 1</div>
		    	<div class="bg-success p-2" style="height: 100px">Flex Item 2</div>
		    	<div class="bg-danger p-2">Flex Item 3</div>
		    </div>		   

		    <h4 class="text-center">Align Items End</h4>
		   <!-- Align the items from the start of the y-axis.
				For flex-row, it is at the bottom. 
				For flex-column, it is at the right.
		    -->
		    <div class="d-flex flex-row align-items-end bg-dark mb-4" style="height:300px">
		    	<div class="bg-primary p-2">Flex Item 1</div>
		    	<div class="bg-success p-2">Flex Item 1</div>
		    	<div class="bg-danger p-2">Flex Item 1</div>
		    </div>		   

		     <h4 class="text-center">Align Items Center</h4>
		   <!-- Align the items from the start of the y-axis.
				For flex-row, it is at the bottom. 
				For flex-column, it is at the right.
		    -->
		    <div class="d-flex flex-row align-items-center bg-dark mb-4" style="height:300px">
		    	<div class="bg-primary p-2">Flex Item 1</div>
		    	<div class="bg-success p-2">Flex Item 1</div>
		    	<div class="bg-danger p-2">Flex Item 1</div>
		    </div>

		    <!-- Align items and Justify Content -->
		    <h4 class="text-center">Aligning vertically and Horizontally - ALign End - Justtify End</h4>
		    <div class="d-flex flex-row align-items-end justify-content-end bg-dark mb-4" style="height:300px">
		    	<div class="bg-primary p-2">Flex Item 1</div>
		    	<div class="bg-success p-2">Flex Item 1</div>
		    	<div class="bg-danger p-2">Flex Item 1</div>
		    </div>		    

		    <h4 class="text-center">Aligning vertically and Horizontally - Align End - Justify Around</h4>
		    <div class="d-flex flex-row align-items-end justify-content-around bg-dark mb-4" style="height:300px">
		    	<div class="bg-primary p-2">Flex Item 1</div>
		    	<div class="bg-success p-2">Flex Item 1</div>
		    	<div class="bg-danger p-2">Flex Item 1</div>
		    </div>		    

		    <h4 class="text-center">Aligning vertically and Horizontally - Align End - Justify Between</h4>
		    <div class="d-flex flex-row align-items-end justify-content-between bg-dark mb-4" style="height:300px">
		    	<div class="bg-primary p-2">Flex Item 1</div>
		    	<div class="bg-success p-2">Flex Item 1</div>
		    	<div class="bg-danger p-2">Flex Item 1</div>
		    </div>
		    <!-- Mini-Activity -->
		    <h4 class="text-center">Flex row, centered vertically and horizontally</h4>
		    <div class="d-flex flex-row align-items-center justify-content-center bg-secondary mb-4" style="height:300px">
		    	<div class="bg-primary p-2">Flex Item 1</div>
		    	<div class="bg-success p-2">Flex Item 1</div>
		    	<div class="bg-danger p-2">Flex Item 1</div>
		    </div>
		    <h4 class="text-center">Flex row, items spaced evenly</h4>
		    <div class="d-flex flex-row align-items-center justify-content-between bg-secondary mb-4" style="height:300px">
		    	<div class="bg-primary p-2">Flex Item 1</div>
		    	<div class="bg-success p-2">Flex Item 1</div>
		    	<div class="bg-danger p-2">Flex Item 1</div>
		    </div>





		<!-- JS dependencies -->
		<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
		<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
	</body>
</html>